#####################################################################
# Copyright (C) 1990
# FourGen Software Technologies, Inc. Edmonds, Washington USA
# Use, modification, duplication, and/or distribution of this
# software is limited to the terms of the software agreement.
# Sccsid:  @(#)  .../data/gl/schema.4gl  1.11  Delta: 2/11/91
#####################################################################


# This file represents the internal definition of
# the tables, columns, indexes, and views.
# It has been automatically generated using FourGen CASE tools.

globals "globals.4gl"

#####################################################################
function define_data()
#####################################################################
#
    define
        a char(18),   # holding bin for the column name
        b smallint,   # holding bin for the column type
        c smallint,   # holding bin for the column length
        d char(1),    # (Y/N) unique index?
        e char(1),    # (Y/N) clustered index?
        f smallint,   # part 1 of index
        g smallint,   # part 2 of index
        h smallint,   # part 3 of index
        i smallint,   # part 4 of index
        j smallint,   # part 5 of index
        k smallint,   # part 6 of index
        l smallint,   # part 7 of index
        m smallint,   # part 8 of index
        n smallint,   # generic counter
        t char(45)    # text portion of the view

    # Set the array boundaries
    let gn_tab = 16    # number of active elements in the tab[] array
    let gx_tab = 16    # maximum number of elements in the tab[] array
    let gn_col = 95   # number of active elements in the col[] array
    let gx_col = 95   # maximum number of elements in the col[] array
    let gn_idx = 12    # number of active elements in the idx[] array
    let gx_idx = 12    # maximum number of elements in the idx[] array
    let gn_viw = 11    # number of active elements in the viw[] array
    let gx_viw = 11    # maximum number of elements in the viw[] array

    # Set some default table elements
    for n = 1 to gn_tab
        let tab[n].col_start = 0
        let tab[n].col_end = 0
        let tab[n].idx_start = 0
        let tab[n].idx_end = 0
        let tab[n].viw_start = 0
        let tab[n].viw_end = 0
    end for

    # Table: pcdtablr
    let tab[1].tabname = "pcdtablr"
    let tab[1].col_start = 1
    let tab[1].col_end = 3
    let tab[1].idx_start = 1
    let tab[1].idx_end = 1
    let tab[1].serial_start = 1000
    for n = 1 to 3
        case n
          when 1  let a="prodid"  let b=0  let c=8
          when 2  let a="line_no"  let b=1  let c=2
          when 3  let a="tabname"  let b=0  let c=18
        end case
        let col[n].colname = a
        let col[n].coltype = b
        let col[n].collength = c
    end for

    # Table: stgstder
    let tab[2].tabname = "stgstder"
    let tab[2].col_start = 4
    let tab[2].col_end = 9
    let tab[2].serial_start = 1000
    for n = 4 to 9
        case n
          when 4  let a="doc_no"  let b=262  let c=4
          when 5  let a="doc_desc"  let b=0  let c=30
          when 6  let a="doc_src"  let b=0  let c=6
          when 7  let a="eop_rev"  let b=0  let c=1
          when 8  let a="file_type"  let b=0  let c=2
          when 9  let a="post_type"  let b=0  let c=1
        end case
        let col[n].colname = a
        let col[n].coltype = b
        let col[n].collength = c
    end for

    # Table: stgcntrc
    let tab[3].tabname = "stgcntrc"
    let tab[3].col_start = 10
    let tab[3].col_end = 19
    let tab[3].serial_start = 1000
    for n = 10 to 19
        case n
          when 10  let a="retain_earnings"  let b=2  let c=4
          when 11  let a="genjrn_doc_no"  let b=258  let c=4
          when 12  let a="genjrn_post_no"  let b=258  let c=4
          when 13  let a="stdent_doc_no"  let b=258  let c=4
          when 14  let a="genled_post_no"  let b=258  let c=4
          when 15  let a="curr_period"  let b=0  let c=2
          when 16  let a="curr_year"  let b=0  let c=4
          when 17  let a="gl_balanced"  let b=0  let c=1
          when 18  let a="dir_db_cr"  let b=0  let c=1
          when 19  let a="setup_date"  let b=7  let c=4
        end case
        let col[n].colname = a
        let col[n].coltype = b
        let col[n].collength = c
    end for

    # Table: stgjoure
    let tab[4].tabname = "stgjoure"
    let tab[4].col_start = 20
    let tab[4].col_end = 27
    let tab[4].serial_start = 1000
    for n = 20 to 27
        case n
          when 20  let a="doc_no"  let b=262  let c=4
          when 21  let a="doc_desc"  let b=0  let c=30
          when 22  let a="doc_date"  let b=7  let c=4
          when 23  let a="doc_src"  let b=0  let c=6
          when 24  let a="auto_rev"  let b=0  let c=1
          when 25  let a="file_type"  let b=0  let c=2
          when 26  let a="posted"  let b=0  let c=1
          when 27  let a="ok_to_post"  let b=0  let c=1
        end case
        let col[n].colname = a
        let col[n].coltype = b
        let col[n].collength = c
    end for

    # Table: stgjourd
    let tab[5].tabname = "stgjourd"
    let tab[5].col_start = 28
    let tab[5].col_end = 34
    let tab[5].idx_start = 2
    let tab[5].idx_end = 2
    let tab[5].serial_start = 1000
    for n = 28 to 34
        case n
          when 28  let a="orig_journal"  let b=256  let c=2
          when 29  let a="doc_no"  let b=258  let c=4
          when 30  let a="line_no"  let b=1  let c=2
          when 31  let a="acct_no"  let b=2  let c=4
          when 32  let a="department"  let b=0  let c=3
          when 33  let a="amount"  let b=5  let c=3327
          when 34  let a="debit_credit"  let b=0  let c=1
        end case
        let col[n].colname = a
        let col[n].coltype = b
        let col[n].collength = c
    end for

    # Table: stgtranr
    let tab[6].tabname = "stgtranr"
    let tab[6].col_start = 35
    let tab[6].col_end = 39
    let tab[6].idx_start = 3
    let tab[6].idx_end = 4
    let tab[6].serial_start = 1000
    for n = 35 to 39
        case n
          when 35  let a="orig_journal"  let b=256  let c=2
          when 36  let a="doc_no"  let b=258  let c=4
          when 37  let a="acct_period"  let b=0  let c=2
          when 38  let a="acct_year"  let b=0  let c=4
          when 39  let a="status"  let b=0  let c=1
        end case
        let col[n].colname = a
        let col[n].coltype = b
        let col[n].collength = c
    end for

    # Table: stgactvd
    let tab[7].tabname = "stgactvd"
    let tab[7].col_start = 40
    let tab[7].col_end = 45
    let tab[7].idx_start = 5
    let tab[7].idx_end = 6
    let tab[7].serial_start = 1000
    for n = 40 to 45
        case n
          when 40  let a="orig_journal"  let b=256  let c=2
          when 41  let a="doc_no"  let b=258  let c=4
          when 42  let a="acct_no"  let b=2  let c=4
          when 43  let a="department"  let b=0  let c=3
          when 44  let a="amount"  let b=5  let c=3327
          when 45  let a="debit_credit"  let b=0  let c=1
        end case
        let col[n].colname = a
        let col[n].coltype = b
        let col[n].collength = c
    end for

    # Table: stxtranr
    let tab[8].tabname = "stxtranr"
    let tab[8].col_start = 46
    let tab[8].col_end = 52
    let tab[8].idx_start = 7
    let tab[8].idx_end = 7
    let tab[8].serial_start = 1000
    for n = 46 to 52
        case n
          when 46  let a="orig_journal"  let b=256  let c=2
          when 47  let a="doc_no"  let b=258  let c=4
          when 48  let a="post_no"  let b=2  let c=4
          when 49  let a="post_date"  let b=7  let c=4
          when 50  let a="doc_date"  let b=263  let c=4
          when 51  let a="ref_code"  let b=0  let c=6
          when 52  let a="doc_desc"  let b=0  let c=30
        end case
        let col[n].colname = a
        let col[n].coltype = b
        let col[n].collength = c
    end for

    # Table: stxchrtd
    let tab[9].tabname = "stxchrtd"
    let tab[9].col_start = 53
    let tab[9].col_end = 60
    let tab[9].idx_start = 8
    let tab[9].idx_end = 8
    let tab[9].serial_start = 1000
    for n = 53 to 60
        case n
          when 53  let a="acct_no"  let b=2  let c=4
          when 54  let a="department"  let b=0  let c=3
          when 55  let a="period_month"  let b=0  let c=2
          when 56  let a="period_year"  let b=0  let c=4
          when 57  let a="activity"  let b=5  let c=3327
          when 58  let a="balance"  let b=5  let c=3327
          when 59  let a="this_month"  let b=5  let c=3327
          when 60  let a="budget"  let b=5  let c=3327
        end case
        let col[n].colname = a
        let col[n].coltype = b
        let col[n].collength = c
    end for

    # Table: stxerorh
    let tab[10].tabname = "stxerorh"
    let tab[10].col_start = 61
    let tab[10].col_end = 66
    let tab[10].idx_start = 9
    let tab[10].idx_end = 9
    let tab[10].serial_start = 1000
    for n = 61 to 66
        case n
          when 61  let a="language"  let b=0  let c=3
          when 62  let a="userdef"  let b=0  let c=1
          when 63  let a="err_module"  let b=0  let c=8
          when 64  let a="err_program"  let b=0  let c=8
          when 65  let a="err_number"  let b=1  let c=2
          when 66  let a="err_line"  let b=0  let c=40
        end case
        let col[n].colname = a
        let col[n].coltype = b
        let col[n].collength = c
    end for

    # Table: stxerord
    let tab[11].tabname = "stxerord"
    let tab[11].col_start = 67
    let tab[11].col_end = 74
    let tab[11].idx_start = 10
    let tab[11].idx_end = 10
    let tab[11].serial_start = 1000
    for n = 67 to 74
        case n
          when 67  let a="language"  let b=0  let c=3
          when 68  let a="userdef"  let b=0  let c=1
          when 69  let a="err_module"  let b=0  let c=8
          when 70  let a="err_program"  let b=0  let c=8
          when 71  let a="err_number"  let b=1  let c=2
          when 72  let a="a_b"  let b=0  let c=1
          when 73  let a="line_no"  let b=1  let c=2
          when 74  let a="err_text"  let b=0  let c=60
        end case
        let col[n].colname = a
        let col[n].coltype = b
        let col[n].collength = c
    end for

    # Table: stxhelpd
    let tab[12].tabname = "stxhelpd"
    let tab[12].col_start = 75
    let tab[12].col_end = 81
    let tab[12].idx_start = 11
    let tab[12].idx_end = 11
    let tab[12].serial_start = 1000
    for n = 75 to 81
        case n
          when 75  let a="language"  let b=0  let c=3
          when 76  let a="userdef"  let b=0  let c=1
          when 77  let a="hlp_module"  let b=0  let c=18
          when 78  let a="hlp_program"  let b=0  let c=18
          when 79  let a="hlp_number"  let b=1  let c=2
          when 80  let a="line_no"  let b=1  let c=2
          when 81  let a="hlp_text"  let b=0  let c=60
        end case
        let col[n].colname = a
        let col[n].coltype = b
        let col[n].collength = c
    end for

    # Table: stxprogr
    let tab[13].tabname = "stxprogr"
    let tab[13].col_start = 82
    let tab[13].col_end = 85
    let tab[13].idx_start = 12
    let tab[13].idx_end = 12
    let tab[13].serial_start = 1000
    for n = 82 to 85
        case n
          when 82  let a="module"  let b=0  let c=8
          when 83  let a="progname"  let b=0  let c=8
          when 84  let a="description"  let b=0  let c=30
          when 85  let a="use_trx"  let b=1  let c=2
        end case
        let col[n].colname = a
        let col[n].coltype = b
        let col[n].collength = c
    end for

    # Table: stxhotkd
    let tab[14].tabname = "stxhotkd"
    let tab[14].col_start = 86
    let tab[14].col_end = 90
    let tab[14].serial_start = 1000
    for n = 86 to 90
        case n
          when 86  let a="hot_key"  let b=1  let c=2
          when 87  let a="act_key"  let b=0  let c=15
          when 88  let a="hot_module"  let b=0  let c=8
          when 89  let a="hot_program"  let b=0  let c=8
          when 90  let a="hot_user"  let b=0  let c=10
        end case
        let col[n].colname = a
        let col[n].coltype = b
        let col[n].collength = c
    end for

    # Table: stxnvgtd
    let tab[15].tabname = "stxnvgtd"
    let tab[15].col_start = 91
    let tab[15].col_end = 95
    let tab[15].serial_start = 1000
    for n = 91 to 95
        case n
          when 91  let a="act_key"  let b=0  let c=15
          when 92  let a="line_no"  let b=1  let c=2
          when 93  let a="nav_module"  let b=0  let c=8
          when 94  let a="nav_program"  let b=0  let c=8
          when 95  let a="nav_user"  let b=0  let c=10
        end case
        let col[n].colname = a
        let col[n].coltype = b
        let col[n].collength = c
    end for

    # Table: stxchrtv
    let tab[16].tabname = "stxchrtv"
    let tab[16].viw_start = 1
    let tab[16].viw_end = 11

    # Indexes:
    for n = 1 to 12
        case n
          when 1
            let a="i1dtablr"  let d="N"  let e="N"
            let f=1  let g=2  let h=0  let i=0
            let j=0  let k=0  let l=0  let m=0
          when 2
            let a="i1gjourd"  let d="N"  let e="N"
            let f=2  let g=3  let h=0  let i=0
            let j=0  let k=0  let l=0  let m=0
          when 3
            let a="i1gtranr"  let d="Y"  let e="N"
            let f=1  let g=2  let h=0  let i=0
            let j=0  let k=0  let l=0  let m=0
          when 4
            let a="i2gtranr"  let d="N"  let e="N"
            let f=5  let g=4  let h=3  let i=0
            let j=0  let k=0  let l=0  let m=0
          when 5
            let a="i1gactvd"  let d="N"  let e="N"
            let f=1  let g=2  let h=0  let i=0
            let j=0  let k=0  let l=0  let m=0
          when 6
            let a="i2gactvd"  let d="N"  let e="N"
            let f=3  let g=4  let h=0  let i=0
            let j=0  let k=0  let l=0  let m=0
          when 7
            let a="i2xtranr"  let d="N"  let e="N"
            let f=6  let g=0  let h=0  let i=0
            let j=0  let k=0  let l=0  let m=0
          when 8
            let a="i1xchrtd"  let d="Y"  let e="N"
            let f=1  let g=2  let h=4  let i=3
            let j=0  let k=0  let l=0  let m=0
          when 9
            let a="i1xerorh"  let d="Y"  let e="N"
            let f=1  let g=2  let h=3  let i=4
            let j=5  let k=0  let l=0  let m=0
          when 10
            let a="i1xerord"  let d="N"  let e="N"
            let f=1  let g=2  let h=3  let i=4
            let j=5  let k=6  let l=7  let m=0
          when 11
            let a="i1xhelpd"  let d="N"  let e="N"
            let f=1  let g=2  let h=3  let i=4
            let j=5  let k=6  let l=0  let m=0
          when 12
            let a="i1xprogr"  let d="N"  let e="N"
            let f=1  let g=2  let h=0  let i=0
            let j=0  let k=0  let l=0  let m=0
        end case
        let idx[n].idxname = a
        let idx[n].unique_idx = d
        let idx[n].clustered = e
        let idx[n].part[1] = f
        let idx[n].part[2] = g
        let idx[n].part[3] = h
        let idx[n].part[4] = i
        let idx[n].part[5] = j
        let idx[n].part[6] = k
        let idx[n].part[7] = l
        let idx[n].part[8] = m
    end for

    # Views:
    for n = 1 to 11
        case n
          when 1 let t="create view  stxchrtv (acct_no,acct_type,acct"
          when 2 let t="_desc,acct_cat,processing_seq,incr_with_crdt,"
          when 3 let t="subtotal_group,department,period_month,period"
          when 4 let t="_year,activity,balance,this_month,budget) as"
          when 5 let t=" select x0.acct_no ,x0.acct_type ,x0.acct_des"
          when 6 let t="c ,x0.acct_cat ,x0.processing_seq ,x0.incr_wi"
          when 7 let t="th_crdt ,x0.subtotal_group ,x1.department ,x1"
          when 8 let t=".period_month ,x1.period_year ,x1.activity ,x"
          when 9 let t="1.balance ,x1.this_month ,x1.budget from  stx"
          when 10 let t="chrtr x0 , stxchrtd x1 where (x0.acct_no = x1"
          when 11 let t=".acct_no ) ;"
        end case
        let viw[n].v_text = t
    end for

end function
# define_data()
