######################################################################
# Copyright (C) 1990
# FourGen Software Technologies, Inc. Edmonds, Washington USA
# Use, modification, duplication, and/or distribution of this
# software is limited to the terms of the software agreement.
# Sccsid:  %Z%  %M%  %I%  Delta: %G%
######################################################################

database standard

globals
    define

        ##############################################################
        # Codegen area
        ##############################################################
        # Global variables in this section will be overwritten
        # during a re-generation of source code.
        # Place any custom global variables above this section.
        # Don't remove these comments.  The codegenerator keys on them.
        #
        m_gcntrc record like stgcntrc.*,  # record holding GL control info
        m_xcntrc record like stxcntrc.*,  # record holding control info
        m_xperdr record like stxperdr.*,  # record holding period info
        dup_flag   smallint,              # for flagging for a duplicate
        dup_prep char(1),
        l_prepared smallint,
        n   smallint,                     # temporary counter
        tmp_month  smallint,              # temporary month holder
        tmp_year   smallint,  # temporary year holder
        m_xchrtr record like stxchrtr.*,  # Record like the header table
        p_xchrtr record   # Record like the header screen
            acct_no like stxchrtr.acct_no,
            acct_type like stxchrtr.acct_type,
            acct_desc like stxchrtr.acct_desc,
            subtotal_group like stxchrtr.subtotal_group,
            incr_with_crdt like stxchrtr.incr_with_crdt
        end record,
        q_xchrtr record   # Parallel header record
            row_id integer  # SQL rowid
        end record,
        m_xchrtd record like stxchrtd.*,  # Record like the detail table
        p_xchrtd array[100] of record   # Record like the detail screen
            department like stxchrtd.department,
            period_month like stxchrtd.period_month,
            period_year like stxchrtd.period_year,
            activity like stxchrtd.activity,
            balance like stxchrtd.balance,
            this_month like stxchrtd.this_month,
            budget like stxchrtd.budget
        end record,
        q_xchrtd array[100] of record   # Parallel detail record
            row_id integer  # SQL rowid
        end record,
        scr1_max smallint,   # Number of elements in screen array 1
        rec1_max smallint,   # Number of elements in record array 1
        rec1_cnt smallint,   # Number of active elements in array 1

        ###############################################################
        # Library communication area 3.51.00
        ###############################################################
        # Global variables in this section should not be changed.
        # They are used to communicate to the screen library functions,
        # and must be of the same type as defined in the library.
        # Don't remove these comments.  The codegenerator keys on them.
        #
        progid       char(17),   # Program identification
        scr_id       char(7),    # Current screen id
        menu_item    char(10),   # Current menu item running
        scr_funct    char(20),   # Current screen function being run
        sql_filter   char(512),  # Filter portion of SQL statement
        sql_order    char(100),  # Order portion of SQL statement
        input_num    smallint,   # Current input section within screen
        p_cur        smallint,   # Current input array element
        s_cur        smallint,   # Current screen array element
        scr_fld      char(40),   # Current screen field
        nxt_fld      char(40),   # Programmatic next screen field
        prev_data    char(80),   # Data before field entry
        this_data    char(80),   # Data after field entry
        data_changed smallint,   # Has the field data changed?
        hotkey       smallint,   # The hot key that has been pressed
        scratch      char(2047)  # Scratchpad for scribbling on and
                                 # communicating between functions
        # End library communication area
        ###############################################################

end globals
