########################################################################
# Copyright (C) 1990
# FourGen Software Technologies, Inc. Edmonds, Washington USA
# Use, modification, duplication, and/or distribution of this
# software is limited to the terms of the software agreement.
# Sccsid:  @(#)  .../gl.4gm/i_chart.4gs/screen.trg  1.3  Delta: 2/11/91
########################################################################
defaults
    define  
        m_gcntrc record like stgcntrc.*,  # record holding GL control info
        m_xcntrc record like stxcntrc.*,  # record holding control info
        m_xperdr record like stxperdr.*,  # record holding period info  
        dup_flag   smallint,              # for flagging for a duplicate
        dup_prep char(1),
        l_prepared smallint,
        n   smallint,                     # temporary counter
        tmp_month  smallint,              # temporary month holder
        tmp_year   smallint               # temporary year holder;

    libraries 
        ../../all.4gm/lib.a;

    after_init
        call gcontrol() returning m_gcntrc.*
        call xcontrol() returning m_xcntrc.*;

input 1

    before_input
        let dup_flag = false;

    before_field incr_with_crdt
        if activity() then let nxt_fld = "acct_no" end if;

    before_field acct_no
        if not dup_flag and activity() 
          then let nxt_fld = "acct_desc" end if;  

    after_field acct_no
        if p_xchrtr.acct_no is null
        then
            let p_xchrtr.acct_no = null
            call lib_error("lib_scr", "lookup", 1, "")
            let nxt_fld = "acct_no"
            return
        end if;

    after_field incr_with_crdt
        if (p_xchrtr.incr_with_crdt != "Y" and
            p_xchrtr.incr_with_crdt != "N") or
            p_xchrtr.incr_with_crdt is null
        then 
            let p_xchrtr.incr_with_crdt = null
            call lib_error("lib_scr", "lookup", 1, "")
            let nxt_fld = "incr_with_crdt"
            return
        else 
            call setype()
        end if;

    after_change_in acct_no
        if dup_key(p_xchrtr.acct_no) 
        then 
            let dup_flag = false
            call setype()
        else
            let dup_flag = true 
            let nxt_fld = "acct_no"
        end if;

    after_input
        if mustfill(p_xchrtr.acct_no,"Account Number")
          then let nxt_fld = "acct_no" return end if
        if mustfill(p_xchrtr.acct_desc,"Account Description")
          then let nxt_fld = "acct_desc" return end if
        if mustfill(p_xchrtr.incr_with_crdt,"Increase w/Credit")
          then let nxt_fld = "incr_with_crdt" return end if;

    at_eof
######################################################################
function fgha_acct_no()
# after field logic for the header field acct_no
######################################################################
# 
    if dup_key(p_xchrtr.acct_no) 
    then 
        let dup_flag = false
        call setype()
    else
        let dup_flag = true 
        let nxt_fld = "acct_no"
        return
    end if

end function
# fgha_acct_no;

input 2
    static_define
        last_row         smallint,# used in collapsing null detail lines
        num_in smallint,     # outer loop counter
        num_out smallint      # inner loop counter;

    before_delete
        if gl_controlled()
        then
            call fg_err(6)  # Cannot delete posted activity
            let nxt_fld = "goto top"
        end if;

    before_field balance
        call fill_line();

    before_field activity
        call fill_line();

    before_field department
        if p_xchrtd[p_cur].department is null
        then
            if p_cur > 1
            then
                let p_xchrtd[p_cur].department = p_xchrtd[p_cur - 1].department
            else
                let p_xchrtd[p_cur].department = "000"
            end if
        end if;

    before_field period_month
        if p_xchrtd[p_cur].period_month is null
        then
            if p_cur > 1
            then
                if p_xchrtd[p_cur].department = p_xchrtd[p_cur - 1].department
                then
                    let n = p_xchrtd[p_cur - 1].period_month + 1
                    if n < 13
                    then
                        let p_xchrtd[p_cur].period_month = n using "&&"
                    end if
                end if
            end if
        end if;

    before_field period_year
        if p_xchrtd[p_cur].period_year is null
        then
            if p_cur > 1
            then
                if p_xchrtd[p_cur].department = p_xchrtd[p_cur - 1].department
                  and p_xchrtd[p_cur].period_month =
                      p_xchrtd[p_cur - 1].period_month + 1
                then
                    let p_xchrtd[p_cur].period_year =
                        p_xchrtd[p_cur - 1].period_year
                end if
            end if
        end if;

    after_field period_month
        if p_xchrtd[p_cur].period_month is null
          then return end if
        whenever error continue
        let tmp_month = p_xchrtd[p_cur].period_month
        whenever error call error_handler
        if status = 0 and tmp_month >= 1 and tmp_month <= 99
        then else
            call scr_error("lookup=notfound", "stxperdr")
            let p_xchrtd[p_cur].period_month = null
            let nxt_fld = "period_month"
            return
        end if
        call datechk();

    after_field period_year
        if p_xchrtd[p_cur].period_year is null
          then return end if
        whenever error continue
        let tmp_year = p_xchrtd[p_cur].period_year
        whenever error call error_handler
        if status = 0 and tmp_year >= 1 and tmp_year <= 9999
        then else
            call scr_error("lookup=notfound", "stxperdr")
            let p_xchrtd[p_cur].period_year = null
            let nxt_fld = "period_year"
            return
        end if
        call datechk();

    after_field department
        call fgda_department();

    after_field balance
        call fgda_balance();

    after_field activity
        if p_xchrtd[p_cur].activity is null
          then let p_xchrtd[p_cur].activity = 0 end if
        let p_xchrtd[p_cur].activity = round("a", p_xchrtd[p_cur].activity);

    after_field budget
        if p_xchrtd[p_cur].budget is null
          then let p_xchrtd[p_cur].budget = 0 end if
        let p_xchrtd[p_cur].budget = round("a", p_xchrtd[p_cur].budget);

    after_input
        let num_in = 0
        let num_out = 0
        for n = 1 to rec1_cnt
          if (p_xchrtd[n].department is null or
              p_xchrtd[n].period_month is null or
              p_xchrtd[n].period_year is null)
          then
              let num_out = num_out + 1
              continue for
          end if
          let num_in = num_in + 1
          let p_xchrtd[num_in].* = p_xchrtd[n].*
          let q_xchrtd[num_in].* = q_xchrtd[n].*
        end for
        initialize p_xchrtd[num_in + 1].* to null
        initialize q_xchrtd[num_in + 1].* to null
        for n = (num_in + 2) to rec1_cnt
          let p_xchrtd[n].* = p_xchrtd[num_in + 1].*
          let q_xchrtd[n].* = q_xchrtd[num_in + 1].*
        end for
        let rec1_cnt = num_in;

    on_disk_record_prep
        if m_xchrtd.balance is null
          then let m_xchrtd.balance = 0 end if;

    at_eof
######################################################################
function fgda_balance()
# after field logic for the detail field balance
######################################################################
# 

     # Trap fatal errors
     let p_xchrtd[p_cur].balance = round("a", p_xchrtd[p_cur].balance)
     if p_xchrtd[p_cur].balance is null and 
        p_xchrtd[p_cur].department is not null
     then
         let p_xchrtd[p_cur].balance = 0
         display p_xchrtd[p_cur].balance to s_chrtd[s_cur].balance
     end if 
     let p_xchrtd[p_cur].this_month = 0
    

end function
# fgda_balance

######################################################################
function fgda_department()
# after field logic for the detail field department
######################################################################
# 

    if p_xchrtd[p_cur].department is null
    then
        initialize p_xchrtd[p_cur].* to null
        display
            p_xchrtd[p_cur].department,
            p_xchrtd[p_cur].period_month, p_xchrtd[p_cur].period_year, 
            p_xchrtd[p_cur].activity, p_xchrtd[p_cur].balance,
            p_xchrtd[p_cur].this_month, p_xchrtd[p_cur].budget
          to
            s_chrtd[s_cur].*
        return
    end if
    call datechk()

end function
# fgda_department

###################################################################
function fgd_after_input()
###################################################################
# checks fields for presence of data, and for duplication.
#

    for n = 1 to rec1_cnt
        if p_xchrtd[n].department is null
        then
            let p_xchrtd[n].period_month = ""
            let p_xchrtd[n].period_year = ""
            let p_xchrtd[n].activity = ""
            let p_xchrtd[n].balance = ""
            let p_xchrtd[n].this_month = ""
            let p_xchrtd[n].budget = ""
        end if
    end for

end function
# fgd_after_input();
