######################################################################
# Copyright (C) 1990
# FourGen Software Technologies, Inc. Edmonds, Washington USA
# Use, modification, duplication, and/or distribution of this
# software is limited to the terms of the software agreement.
# Sccsid:  %Z%  %M%  %I%  Delta: %G%
######################################################################

database standard

globals
    define

        ##############################################################
        # Codegen area
        ##############################################################
        # Global variables in this section will be overwritten
        # during a re-generation of source code.
        # Place any custom global variables above this section.
        # Don't remove these comments.  The codegenerator keys on them.
        #
        m_xcntrc record like stxcntrc.*,  # record holding GL control info
        post_gl record
            gl_installed char(1),
            last_doc_no integer,
            status smallint,
            description char(60),
            acct_period like stgtranr.acct_period,
            acct_year like stgtranr.acct_year,
            acct_desc char(30),
            incr_with_crdt char(1),
            signed_amount like stgactvd.amount,
            cr_accum like stgactvd.amount,
            db_accum like stgactvd.amount
        end record,
        n    smallint,     # temporary working number
        m    smallint,     # temporary working number
        per    char(2),    # temporary period holder
        yr     char(4),  # temporary year holder
        m_gcntrc record like stgcntrc.*,  # Record like the header table
        p_gcntrc record   # Record like the header screen
            curr_period like stgcntrc.curr_period,
            curr_year like stgcntrc.curr_year,
            retain_earnings like stgcntrc.retain_earnings,
            dir_db_cr like stgcntrc.dir_db_cr,
            setup_date like stgcntrc.setup_date,
            gl_balanced like stgcntrc.gl_balanced
        end record,
        q_gcntrc record   # Parallel header record
            row_id integer  # SQL rowid
        end record,
        m_xperdr record like stxperdr.*,  # Record like the detail table
        p_xperdr array[100] of record   # Record like the detail screen
            period like stxperdr.period,
            period_year like stxperdr.period_year,
            start_date like stxperdr.start_date,
            end_date like stxperdr.end_date,
            balanced like stxperdr.balanced
        end record,
        q_xperdr array[100] of record   # Parallel detail record
            row_id integer  # SQL rowid
        end record,
        scr1_max smallint,   # Number of elements in screen array 1
        rec1_max smallint,   # Number of elements in record array 1
        rec1_cnt smallint,   # Number of active elements in array 1

        ###############################################################
        # Library communication area 3.51.00
        ###############################################################
        # Global variables in this section should not be changed.
        # They are used to communicate to the screen library functions,
        # and must be of the same type as defined in the library.
        # Don't remove these comments.  The codegenerator keys on them.
        #
        progid       char(17),   # Program identification
        scr_id       char(7),    # Current screen id
        menu_item    char(10),   # Current menu item running
        scr_funct    char(20),   # Current screen function being run
        sql_filter   char(512),  # Filter portion of SQL statement
        sql_order    char(100),  # Order portion of SQL statement
        input_num    smallint,   # Current input section within screen
        p_cur        smallint,   # Current input array element
        s_cur        smallint,   # Current screen array element
        scr_fld      char(40),   # Current screen field
        nxt_fld      char(40),   # Programmatic next screen field
        prev_data    char(80),   # Data before field entry
        this_data    char(80),   # Data after field entry
        data_changed smallint,   # Has the field data changed?
        hotkey       smallint,   # The hot key that has been pressed
        scratch      char(2047)  # Scratchpad for scribbling on and
                                 # communicating between functions
        # End library communication area
        ###############################################################

end globals
