########################################################################
# Copyright (C) 1990
# FourGen Software Technologies, Inc. Edmonds, Washington USA
# Use, modification, duplication, and/or distribution of this
# software is limited to the terms of the software agreement.
# Sccsid:  @(#)  .../gl.4gm/i_contrl.4gs/screen.trg  1.7  Delta: 2/11/91
########################################################################

defaults

    define  
        m_xcntrc record like stxcntrc.*,  # record holding GL control info
        post_gl record
            gl_installed char(1),
            last_doc_no integer,
            status smallint,
            description char(60),
            acct_period like stgtranr.acct_period,
            acct_year like stgtranr.acct_year,
            acct_desc char(30),
            incr_with_crdt char(1),
            signed_amount like stgactvd.amount,
            cr_accum like stgactvd.amount,
            db_accum like stgactvd.amount
        end record,
        n    smallint,     # temporary working number
        m    smallint,     # temporary working number
        per    char(2),    # temporary period holder
        yr     char(4)     # temporary year holder;

    libraries
        ../../all.4gm/lib.a;

    after_init
        call getrec1()
        call xcontrol() returning m_xcntrc.*;
   
    do_not_generate
        lld_read
        lld_m_prep
        lld_delete;

    at_eof
##################################################################
function ok_browse()
# returning true or false based upon ok to delete
##################################################################
#
call fg_err(32) #This function has been disabled 
return false
end function
# ok_browse

##################################################################
function ok_delete()
# returning true or false based upon ok to delete
##################################################################
#

call fg_err(32) #This function has been disabled 
return false
end function
# ok_delete

##################################################################
function ok_add()
# returning true or false based upon ok to delete
##################################################################
#

call fg_err(32) #This function has been disabled 
return false
end function
# ok_add

##################################################################
function ok_find()
# returning true or false based upon ok to delete
##################################################################
#

call fg_err(32) #This function has been disabled 
return false
end function
# ok_find

##################################################################
function ok_next()
# returning true or false based upon ok to delete
##################################################################
#

call fg_err(32) #This function has been disabled 
return false
end function
# ok_next

##################################################################
function ok_prev()
# returning true or false based upon ok to delete
##################################################################
#

call fg_err(32) #This function has been disabled 
return false
end function
# ok_prev;

input 1

    before_field curr_period
        if p_gcntrc.gl_balanced = "Y" and m_gcntrc.gl_balanced = "Y"
          then let nxt_fld = "dir_db_cr" end if;

    after_field curr_period
        call fgha_curr_period();

    after_field curr_year
        call fghb_curr_year();
 
    before_field gl_balanced
        if p_gcntrc.gl_balanced is null
          then let p_gcntrc.gl_balanced = "N" end if
        if p_gcntrc.gl_balanced = "Y"
          then let nxt_fld = "retain_earnings" return end if;

    before_field dir_db_cr
        if p_gcntrc.dir_db_cr is null 
          then let p_gcntrc.dir_db_cr = "N" end if;

    after_field dir_db_cr
        if (p_gcntrc.dir_db_cr != "Y" and 
            p_gcntrc.dir_db_cr != "N") or
            p_gcntrc.dir_db_cr is null
        then 
            let p_gcntrc.dir_db_cr = null
            call lib_error("lib_scr", "lookup", 1, "")
            let nxt_fld = "dir_db_cr"
            return
        end if
        if p_gcntrc.gl_balanced = "Y" and m_gcntrc.gl_balanced = "Y"
          then let nxt_fld = "dir_db_cr" end if;

    after_field gl_balanced
        if (p_gcntrc.gl_balanced != "Y" and 
            p_gcntrc.gl_balanced != "N") or
            p_gcntrc.gl_balanced is null
        then 
            let p_gcntrc.gl_balanced = null
            call lib_error("lib_scr", "lookup", 1, "")
            let nxt_fld = "gl_balanced"
            return
        end if;

    after_field curr_period
        if p_gcntrc.curr_period = "00"
          then let nxt_fld = "curr_period" end if;

    after_change_in retain_earnings
        call fgha_retain_earnings();

    after_input
        if p_gcntrc.gl_balanced = "Y" and m_gcntrc.gl_balanced = "N"
        then
            if mustfill(p_gcntrc.curr_period,"Current Period") 
              then let nxt_fld = "curr_period" return end if
            if mustfill(p_gcntrc.curr_year,"Current Year") 
              then let nxt_fld = "curr_year" return end if
            if mustfill(p_gcntrc.retain_earnings,"Retained Earnings")
              then let nxt_fld = "retain_earnings" return end if
            if mustfill(p_gcntrc.dir_db_cr,"Direct DB/CR Entry") 
              then let nxt_fld = "dir_db_cr" return end if
            if mustfill(p_gcntrc.setup_date,"Setup Complete Date")
              then let nxt_fld = "setup_date" return end if
            if  p_gcntrc.retain_earnings >= m_xcntrc.income
             or p_gcntrc.retain_earnings <  m_xcntrc.capital
            then
                # Retain earning must be in Capital range.
                call fg_err(1)
                let nxt_fld = "curr_period" 
                return
            end if
        end if
        if not tab_pressed
        then
            if not valid_periods()
              then let tab_pressed = true return end if
            if p_gcntrc.gl_balanced = "Y" and m_gcntrc.gl_balanced = "N"
            then
                if close_setup() = false
                then  
                    let p_gcntrc.gl_balanced = "N"  
                    call ok_cancel("Y")
                    let int_flag = -1
                end if
            end if
        end if;

input 2

    static_define
        z_flag    smallint,
        num_in    smallint,
        num_out   smallint;
 
    before_insert
        let scr_fld = null;

    before_row
        if p_xperdr[p_cur].balanced = "Y"  # disable delete key
        then 
          options delete key f36
          return 
        else 
          options delete key f2
        end if;

    before_field period
        call fgdb_period();

    before_field period_year
        call fgdb_period_year();

    before_field start_date
        call fgdb_start_date();

    before_field end_date
        call fgdb_end_date();

    after_field period
        if p_xperdr[p_cur].period = "00"
        then
            let p_xperdr[p_cur].period = null
            call lib_error("lib_scr", "lookup", 1, "")
            let nxt_fld = "period"
            return
        end if
        if p_xperdr[p_cur].period is not null
          then call datechk() end if;

    after_change_in period_year
        call datechk();

    after_field end_date
       call fgda_end_date();

    after_input
       let num_in = 0
       let num_out = 0
       for n = 1 to rec1_cnt
         if (p_xperdr[n].period is null or 
             p_xperdr[n].period_year is null or 
             p_xperdr[n].start_date is null or 
             p_xperdr[n].end_date is null)
         then
             let num_out = num_out + 1
             continue for
         end if
         let num_in = num_in + 1
         let p_xperdr[num_in].* = p_xperdr[n].*
         let q_xperdr[num_in].* = q_xperdr[n].*
       end for
       initialize p_xperdr[num_in + 1].* to null
       initialize q_xperdr[num_in + 1].* to null
       for n = (num_in + 2) to rec1_cnt
         let p_xperdr[n].* = p_xperdr[num_in + 1].*
         let q_xperdr[n].* = q_xperdr[num_in + 1].*
       end for
       let rec1_cnt = num_in
       call lld_display()

       if not tab_pressed
       then
           if valid_periods() = false
             then let nxt_fld = "goto top" return end if
           if p_gcntrc.gl_balanced = "Y" and m_gcntrc.gl_balanced = "N"
           then
               if close_setup() = false
               then  
                   let p_gcntrc.gl_balanced = "N"  
                   call ok_cancel("Y")
                   let int_flag = -1
               end if
           end if 
       end if;
